import com.urbancode.air.AirPluginTool
import com.urbancode.air.CommandHelper

//sdk imports
import com.amazonaws.AmazonServiceException;
import com.amazonaws.auth.AWSCredentials;
import com.amazonaws.auth.BasicAWSCredentials;
import com.amazonaws.services.ec2.AmazonEC2;
import com.amazonaws.services.ec2.AmazonEC2Client;
import com.amazonaws.services.ec2.model.AuthorizeSecurityGroupIngressRequest;
import com.amazonaws.services.ec2.model.CreateSecurityGroupRequest;
import com.amazonaws.services.ec2.model.IpPermission;
import com.amazonaws.services.ec2.model.DescribeInstancesRequest;
import com.amazonaws.services.ec2.model.DescribeInstancesResult;
import com.amazonaws.services.ec2.model.Reservation;
import com.amazonaws.services.ec2.model.Instance;


def ch = new CommandHelper(new File('.'));
def apTool = new AirPluginTool(this.args[0], this.args[1]);
def props = apTool.getStepProperties();

def accessKeyId = props['accessKeyId'];
def secretKey = props['secretKey'];
def instanceIds = props['instanceIds'].split(',');

def dnses = [];

AWSCredentials creds = null;
creds = new BasicAWSCredentials(accessKeyId, secretKey);

AmazonEC2 ec2 = new AmazonEC2Client(creds);


DescribeInstancesRequest req = new DescribeInstancesRequest().withInstanceIds(instanceIds);

DescribeInstancesResult result = ec2.describeInstances(req);

List<Instance> instances = new ArrayList<Instance>();
List<Reservation> reservations = result.getReservations();
reservations.each { reservation ->
    List<Instance> currInstances = reservation.getInstances();
    instances.addAll(currInstances);
}

instanceIds.each { instanceId ->
    Instance instance = instances.find { it.getInstanceId() == instanceId };
    dnses << instance.getPublicDnsName();
}
    
apTool.setOutputProperty("dns", dnses.join(','));
apTool.setOutputProperties();
